#ifndef SHAPE_H_INCLUDED
#define SHAPE_H_INCLUDED

typedef enum {
    COLOR_BLACK,                /*  */
    COLOR_BLUE,                 /*  */
    COLOR_RED,                  /*  */
    COLOR_MAGENTA,              /*  */
    COLOR_GREEN,                /*  */
    COLOR_CYAN,                 /* 忧 */
    COLOR_YELLOW,               /*  */
    COLOR_WHITE                 /*  */
} Color;

typedef enum {
    FILL_NONE,                  /* ɤ٤ʤ */
    FILL_SOLID,                 /* ٤ɤ */
    FILL_HATCH,                 /* ˤϥå */
    FILL_CROSSHATCH             /* 򺹤ϥå */
} FillPattern;

typedef enum {
    POLYLINE_PRIMITIVE,
    RECTANGLE_PRIMITIVE,
    CIRCLE_PRIMITIVE,
} PrimitiveType;

typedef struct {
    double      x;
    double      y;
} Point;

typedef struct {
    int         npoints;
    Point       *point;
} Polyline;

typedef struct {
    Point       minPoint;       /* κɸ */
    Point       maxPoint;       /* κɸ */
} Rectangle;

typedef struct {
    Point       center;         /* 濴 */
    double      radius;         /* Ⱦ */
} Circle;

typedef struct {
    /* ڥ(س)ο*/
    Color       pen_color;
    /* ɤ٤ѥFILL_NONEλˤɤ٤ʤ */
    FillPattern fill_pattern;
    /* ɤ٤ο */
    Color       fill_color;
    /* ޷μ */
    PrimitiveType   type;
    union {
        Polyline        polyline;
        Rectangle       rectangle;
        Circle          circle;
    } u;
} Primitive;

typedef struct Shape_tag Shape;

typedef struct {
    Shape   *head;
    Shape   *tail;
} Group;

typedef enum {
    PRIMITIVE_SHAPE,
    GROUP_SHAPE
} ShapeType;

struct Shape_tag {
    ShapeType           type;
    union {
        Primitive       primitive;
        Group           group;
    } u;
    struct Shape_tag *prev;
    struct Shape_tag *next;
};

#endif /* SHAPE_H_INCLUDED */
